---
title: Element.scrollWidth
slug: Web/API/Element/scrollWidth
tags:
  - API
  - CSSOM View
  - NeedsMarkupWork
  - NeedsSpecTable
  - Property
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>The <strong><code>Element.scrollWidth</code></strong> read-only property is a measurement of the width of an element's content, including content not visible on the screen due to overflow.</p>

<p>The <code>scrollWidth</code> value is equal to the minimum width the element would require in order to fit all the content in the viewport without using a horizontal scrollbar. The width is measured in the same way as {{domxref("Element.clientWidth", "clientWidth")}}: it includes the element's padding, but not its border, margin or vertical scrollbar (if present). It can also include the width of pseudo-elements such as {{cssxref("::before")}} or {{cssxref("::after")}}. If the element's content can fit without a need for horizontal scrollbar, its <code>scrollWidth</code> is equal to {{domxref("Element.clientWidth", "clientWidth")}}</p>

<div class="note">
<p>This property will round the value to an integer. If you need a fractional value, use {{ domxref("element.getBoundingClientRect()") }}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>xScrollWidth</var> = <var>element</var>.scrollWidth;</pre>

<p><code><var>xScrollWidth</var></code> is the width of the content of <code><var>element</var></code> in pixels.</p>

<h2 id="Example">Example</h2>

<pre class="brush:html">&lt;!DOCTYPE html&gt;
&lt;html&gt;
&lt;head&gt;
    &lt;title&gt;Example&lt;/title&gt;
    &lt;style&gt;
        div {
            overflow: hidden;
            white-space: nowrap;
            text-overflow: ellipsis;
        }

        #aDiv {
            width: 100px;
        }

        button {
            margin-bottom: 2em;
        }
    &lt;/style&gt;
&lt;/head&gt;

&lt;body&gt;
    &lt;div id="aDiv"&gt;
        FooBar-FooBar-FooBar-FooBar
    &lt;/div&gt;
    &lt;button id="aButton"&gt;
        Check for overflow
    &lt;/button&gt;

    &lt;div id="anotherDiv"&gt;
        FooBar-FooBar-FooBar-FooBar
    &lt;/div&gt;
    &lt;button id="anotherButton"&gt;
        Check for overflow
    &lt;/button&gt;
&lt;/body&gt;
&lt;script&gt;
    var buttonOne = document.getElementById('aButton'),
    buttonTwo = document.getElementById('anotherButton'),
    divOne = document.getElementById('aDiv'),
    divTwo = document.getElementById('anotherDiv');

    //check to determine if an overflow is happening
    function isOverflowing(element) {
        return (element.scrollWidth &gt; element.offsetWidth);
    }

    function alertOverflow(element) {
        if (isOverflowing(element)) {
            alert('Contents are overflowing the container.');
        } else {
            alert('No overflows!');
        }
    }

    buttonOne.addEventListener('click', function() {
        alertOverflow(divOne);
    });

    buttonTwo.addEventListener('click', function() {
        alertOverflow(divTwo);
    });
&lt;/script&gt;
&lt;/html&gt;
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Example')}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th>Specification</th>
			<th>Status</th>
			<th>Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName("CSSOM View", "#dom-element-scrollwidth", "Element.scrollWidth")}}</td>
			<td>{{Spec2("CSSOM View")}}</td>
			<td>Initial definition</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.scrollWidth")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref("Element.clientWidth")}}</li>
	<li>{{domxref("HTMLElement.offsetWidth")}}</li>
	<li><a href="/en-US/docs/Web/API/CSS_Object_Model/Determining_the_dimensions_of_elements">Determining the dimensions of elements</a></li>
</ul>
